<?php

 $subject = "Added via email";
function add_message($text)
{
  global $message;
  $message .= ($message == '' ? '' : "<br/>\n") . $text;
}

function check_libraries()
{
  $ret = true;
  if ( !function_exists('imap_open') )
  {
    add_message('Error: Required IMAP library not found!');
  }
  return $ret;
}



function save_images($mbox, $msgNo, $message_structure, $pno = '')
{
 	
		     
  global $album, $folder, $filepath, $max_file_size, $my_images, $allowed_filetypes, $subject;
  $ret = true;
  if( $message_structure->type == 1 )
  {
    $jk = 1;
    foreach($message_structure->parts as $part)
    {
      save_images($mbox, $msgNo, $part, $pno . ($pno == '' ? '' : '.') . $jk++);
    }
  }
  else if ( $message_structure->type == 2 )
  {
    save_images($mbox, $msgNo, $message_structure->parts[0], $pno);
  }
  else
  {
    $can_be_an_image = false;
    if ( $message_structure->type == 3 )
    {
      $filename = '';
      for ($j = 0; $j < $message_structure->ifdparameters; $j++)
      {
        if ( $message_structure->dparameters[$j]->attribute == 'FILENAME' )
        {
          $filename = $message_structure->dparameters[$j]->value;
        }
      }
      $ext = strrpos($filename, '.');
      $ext = ($ext === false || $ext == strlen($filename) - 1 ? '' : substr($filename, $ext + 1));
      if ( in_array(strtolower($ext), $allowed_filetypes) )
      {
        $can_be_an_image = true;
      }
    }
    if ( $message_structure->type == 5 )
    {
      $can_be_an_image = true;
    }
    if( $can_be_an_image )
    {
      $filename = '';
      for ($j = 0; $j < $message_structure->ifdparameters; $j++)
      {
        if ( $message_structure->dparameters[$j]->attribute == 'FILENAME' )
        {
          $filename = $message_structure->dparameters[$j]->value;
        }
      }
      if ( $filename == '' )
      {
        $filename = (isset($message_structure->id) && $message_structure->id != '' ? str_replace(array('<', '>'), array('', ''), $message_structure->id) : '');
      }
      $size = $message_structure->bytes;
      if ( $size <= $max_file_size && $filename != '' )
      {
        $bin = imap_fetchbody($mbox, $msgNo, $pno, FT_INTERNAL);
        if ( $message_structure->encoding == 0 )
        {
          $decoded = imap_7bit($bin);
        }
        else if ( $message_structure->encoding == 1 )
        {
          $decoded = imap_8bit($bin);
        }
        else if ( $message_structure->encoding == 2 )
        {
          $decoded = imap_binary($bin);
        }
        else if ( $message_structure->encoding == 3 )
        {
          $decoded = imap_base64($bin);
        }
        else if ( $message_structure->encoding == 4 )
        {
          $decoded = quoted_printable_decode($bin);
        }
        else if ( $message_structure->encoding == 5 )
        {
          $decoded = $bin;
        }
        $ext = strrpos($filename, '.');
        $ext = ($ext === false || $ext == strlen($filename) - 1 ? '' : strtolower(substr($filename, $ext + 1)));
        if ( !in_array($ext, $allowed_filetypes) )
        {
          if ( strlen($decoded) > 2 && substr($decoded, 0, 3) == 'GIF' )
          {
            $ext = 'gif';
          }
          else if ( strlen($decoded) > 9 && in_array(strtolower(substr($decoded, 6, 4)), array('jfif', 'exif')) )
          {
            $ext = 'jpg';
          }
          else if ( strlen($decoded) > 3 && strtolower(substr($decoded, 1, 3)) == 'png' )
          {
            $ext = 'png';
          }
          else if ( strlen($decoded) > 1 && strtolower(substr($decoded, 0, 2)) == 'bm' )
          {
            $ext = 'bmp';
          }
          else
          {
            add_message("Error: Unknown file format '$ext'");
            return false;
          }
        }
        $name = 0;
        $e = true;
        while ( $e )
        {
          $e = false;
          ++$name;
          foreach ($allowed_filetypes as $ft)
          {
            if ( file_exists($filepath . $name . '.' . $ft) )
            {
              $e = true;
              break;
            }
          }
        }
        $name .= '.' . $ext;
        if( $fh = fopen($filepath . $name, 'w') )
        {
 
          fwrite($fh, $decoded, strlen($decoded));
          $my_images[] = $name;
          add_picture($album, $folder, $name, 0, $subject);//was filename not $name 0, $subject added along with 1 other entry for subject to title hack
          fclose($fh);
        }
        else
        {
          add_message('Error: File write error!');
          $ret = false;
        }
      }
    }
  }
  return $ret;
}

class attachtoserver
{

  
 function getdata($pop3emailhost,$login,$password,$filepath,$album,$folder)
			{
				
				global $subject, $from, $subject;
    
 if ( $mbox = imap_open($pop3emailhost,$login,$password) )
  {
	        
    if ( $mnum = imap_num_msg($mbox) )
    {
	    
      for ($jk = 1; $jk <= $mnum; $jk++)
      {
	      $headerinfo = imap_header($mbox, $jk);
       $subjectwithapos = $headerinfo->Subject;
      
       $subject = str_replace("'", "&#039;", "$subjectwithapos");// This fixes a MYSQL error if someone puts an ' in the subject and converts it using HTML iso . 
     
       if (isset($headerinfo->from[0]->personal)) {
            $personal = $headerinfo->from[0]->personal;
        } else {
            $personal = $headerinfo->from[0]->mailbox;
        }
$matches = array();
                        if (preg_match('/^=\?[^?]*\?B\?(.*)\?=/m', $personal, $matches))
                                $personal = base64_decode($matches[1]);
       
      $subject = $subject . " Emailed by " . $personal;
       
       $subject = str_replace("Fwd:", "", "$subject");
      
                
        if ( !save_images($mbox, $jk, imap_fetchstructure($mbox, $jk)) )
        {
	        
         $ret = false;
          break;
        }
        
        
       imap_delete($mbox, $jk);
      }
    }
    imap_close($mbox, CL_EXPUNGE);
  }
  
  
  else
 {
	 echo "Error Connecting to $pop3emailhost!!";
    add_message('Error connecting to ' . $pop3emailhost . ': Invalid login data or access denied!');
    $ret = false;
  }
     
  return $ret;
}

}


?>
